GLOBAL.setmetatable(GLOBAL.getfenv(1), {__index = function(self, index)
	return GLOBAL.rawget(GLOBAL, index)
end})-- ty penguin

local unpack = unpack or table.unpack or GLOBAL.unpack

local function results(data, ...)
	return type(data) == "function" and {data(...)}  
		or type(data) == "table" and data 
		or {data} 
end 

local function sandwich(func, ante, post)	
	return function(...)
		local results_ante = results(ante, ...)
		if #results_ante > 0 then return unpack(results_ante) end 		
		
		local results_original = results(func, ...)
		
		local results_post = results(post, ...)
		if #results_post > 0 then return unpack(results_post) end 
		
		return unpack(results_original)
	end 
end 

local function overwrite(tabula, name, ante, post)
	if type(tabula) ~= "table" then return end 
	local old = tabula[name]
	tabula[name] = sandwich(old, ante, post)
end 

--			*			*			*			*			*			*			--

TUNING.GOAT_REMILKABLE_TIME = 480 * 2

local MILK_GOAT = Action{}
MILK_GOAT.str = "Milk"
MILK_GOAT.id = "MILK_GOAT"

MILK_GOAT.fn = function(act)
	if act.invobject and act.invobject.components.goat_milker 
	and act.target and act.target.components.goat_milkable then 
		return act.target.components.goat_milkable:Milk(act.doer, act.invobject)
	end 
end

AddAction(MILK_GOAT)
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.MILK_GOAT, "dolongaction"))

AddPrefabPostInit("messagebottleempty", function(inst)
	inst:AddComponent"goat_milker"
end)

AddPrefabPostInit("lightninggoat", function(inst)
	inst:AddComponent"goat_milkable"
end)